all_maps = {
    "measurements": {"measurement_sweep_rate": "hyst_sweep_rate", "treatment_ac_field": "treat_ac_field", "er_citation_names": "citations", "measurement_time_zone": "timestamp", "measurement_pos_x": "meas_pos_x", "treatment_ac_field_dc_off": "treat_ac_field_dc_off", "measurement_inc": "dir_inc", "measurement_date": "timestamp", "measurement_freq": "meas_freq", "measurement_dec": "dir_dec", "treatment_dc_field_ac_on": "treat_dc_field_ac_on", "measurement_lab_field_ac": "meas_field_ac", "treatment_dc_field": "treat_dc_field", "measurement_chi_qdr_volume": "susc_chi_qdr_volume", "measurement_r2": "magn_r2_det", "measurement_chi_mass": "susc_chi_mass", "treatment_temp_dc_off": "treat_temp_dc_off", "measurement_number": "number", "treatment_temp_dc_on": "treat_temp_dc_on", "measurement_standard": "standard", "er_analyst_mail_names": "analysts", "magic_method_codes": "method_codes", "treatment_dc_field_phi": "treat_dc_field_phi", "measurement_description": "description", "measurement_orient_phi": "meas_orient_phi", "treatment_mw_integral": "treat_mw_integral", "treatment_ac_field_dc_on": "treat_ac_field_dc_on", "treatment_temp": "treat_temp", "er_specimen_name": "specimen", "er_synthetic_name": "specimen", "measurement_loop_x": "hyst_loop", "treatment_mw_time": "treat_mw_time", "treatment_mw_power": "treat_mw_power", "measurement_charging_mode": "hyst_charging_mode", "measurement_temp": "meas_temp", "measurement_magn_moment": "magn_moment", "measurement_magn_volume": "magn_volume", "magic_instrument_codes": "instrument_codes", "measurement_sd_z": "magn_z_sigma", "measurement_sd_y": "magn_y_sigma", "measurement_sd_x": "magn_x_sigma", "magic_experiment_name": "experiment", "external_database_ids": "external_database_ids", "measurement_pos_y": "meas_pos_y", "measurement_lab_field_dc": "meas_field_dc", "measurement_orient_theta": "meas_orient_theta", "measurement_sd": "magn_xyz_sigma", "measurement_temp_change": "meas_temp_change", "magic_software_packages": "software_packages", "treatment_ac_field_decay_rate": "treat_ac_field_decay_rate", "treatment_dc_field_theta": "treat_dc_field_theta", "external_database_names": "external_database_ids", "treatment_dc_field_decay_rate": "treat_dc_field_decay_rate", "treatment_mw_energy": "treat_mw_energy", "measurement_positions": "meas_n_orient", "treatment_dc_field_ac_off": "treat_dc_field_ac_off", "measurement_csd": "dir_csd", "measurement_flag": "quality", "measurement_chi_qdr_mass": "susc_chi_qdr_mass", "measurement_magn_mass": "magn_mass", "measurement_chi_volume": "susc_chi_volume", "treatment_temp_decay_rate": "treat_temp_decay_rate", "measurement_pos_z": "meas_pos_z"},
    "ages": {"timescale_eon": "timescale_eon", "er_citation_names": "citations", "tiepoint_alternatives": "tiepoint_alternatives", "age_range_high": "age_high", "age_description": "description", "timescale_stage": "timescale_stage", "astronomical_stage": "astronomical_stage", "biostrat_zone": "biostrat_zone", "tiepoint_elevation": "tiepoint_elevation", "tiepoint_height_sigma": "tiepoint_height_sigma", "er_location_name": "location", "magic_method_codes": "method_codes", "oxygen_stage": "oxygen_stage", "tiepoint_height": "tiepoint_height", "tiepoint_name": "tiepoint", "er_specimen_name": "specimen", "tiepoint_type": "tiepoint_type", "age_sigma": "age_sigma", "er_sample_name": "sample", "timescale_period": "timescale_period", "timescale_epoch": "timescale_epoch", "conodont_zone": "conodont_zone", "er_site_name": "site", "age": "age", "timescale_era": "timescale_era", "age_unit": "age_unit", "age_culture_name": "culture", "magnetic_reversal_chron": "magnetic_reversal_chron", "er_timescale_citation_names": "timescale_citations", "age_range_low": "age_low"},
    "sites": {"er_citation_names": "citations", "er_site_name": "site", "site_lithology": "lithologies", "site_int_sigma": "int_abs_sigma", "site_height": "height", "er_sample_names": "samples", "site_core_depth": "core_depth", "site_comp_nmb": "dir_comp_name", "site_nrm": "dir_nrm_origin", "er_specimen_names": "specimens", "site_n_planes": "dir_n_specimens_planes", "site_elevation": "elevation", "site_comp_n": "dir_n_comps", "site_alpha95": "dir_alpha95", "site_flag": "result_quality", "site_type": "geologic_types", "magic_software_packages": "software_packages", "site_inc": "dir_inc", "site_int_rel_sigma_perc": "int_rel_sigma_perc", "magic_method_codes": "method_codes", "er_scientist_mail_names": "scientists", "site_bed_dip": "bed_dip", "er_location_name": "location", "site_igsn": "igsn", "site_int_rel": "int_rel", "site_magn_mass": "magn_mass", "site_comp_name": "dir_comp_name", "site_dec": "dir_dec", "site_n_lines": "dir_n_specimens_lines", "site_location_precision": "geographic_precision", "site_class": "geologic_classes", "pmag_criteria_codes": "criteria", "site_tilt_correction": "dir_tilt_correction", "site_int_n": "int_n_samples", "site_bed_dip_direction": "bed_dip_direction", "site_inferred_age": "age", "magic_instrument_codes": "instrument_codes", "site_lon": "lon", "site_inferred_age_unit": "age_unit", "external_database_ids": "external_database_ids", "site_inferred_age_high": "age_high", "er_analyst_mail_names": "analysts", "er_site_alternatives": "site_alternatives", "site_k": "dir_k", "site_int_rel_sigma": "int_rel_sigma", "site_inferred_age_low": "age_low", "site_n": "dir_n_samples", "magic_experiment_names": "experiments", "site_inferred_age_sigma": "age_sigma", "er_synthetic_names": "specimens", "site_polarity": "dir_polarity", "site_cooling_rate": "cooling_rate", "site_magn_volume": "magn_volume", "site_lat": "lat", "site_description": "description", "site_composite_depth": "composite_depth", "site_n_total": "dir_n_specimens", "external_database_names": "external_database_ids", "site_r": "dir_r", "site_int": "int_abs", "site_int_sigma_perc": "int_abs_sigma_perc"},
    "locations": {"er_citation_names": "citations", "location_precision": "lat_lon_precision", "location_end_elevation": "elevation_high", "tectonic_setting": "tectonic_settings", "location_begin_lat": "lat_s", "location_url": "expedition_url", "village_city": "village_city", "continent_ocean": "continent_ocean", "terrane": "terranes", "location_begin_lon": "lon_w", "er_location_name": "location", "er_scientist_mail_names": "scientists", "location_end_lat": "lat_s", "location_begin_elevation": "elevation_low", "geological_province_section": "geological_province_sections", "ocean_sea": "ocean_sea", "er_location_alternatives": "location_alternatives", "location_type": "location_type", "plate_block": "plate_blocks", "location_lithology": "lithologies", "country": "country", "region": "region", "location_class": "geologic_classes", "location_description": "description", "location_end_lon": "lon_w"},
    "samples": {"er_citation_names": "citations", "sample_lithology": "lithologies", "sample_alteration_type": "alteration_type", "sample_lat": "lat", "sample_int_rel": "int_rel", "sample_alteration": "alteration_grade", "er_specimen_names": "specimens", "sample_time_zone": "timestamp", "sample_int_sigma": "int_abs_sigma", "sample_dec": "dir_dec", "sample_bed_dip_direction": "bed_dip_direction", "magic_software_packages": "software_packages", "sample_azimuth": "azimuth", "sample_location_precision": "lat_lon_precision", "sample_bed_dip": "bed_dip", "sample_description": "description", "sample_nrm": "dir_nrm_origin", "sample_type": "geologic_types", "sample_comp_nmb": "dir_comp_name", "sample_height": "height", "sample_int_rel_sigma_perc": "int_rel_sigma_perc", "sample_int_sigma_perc": "int_abs_sigma_perc", "sample_int_n": "int_n_specimens", "sample_cooling_rate": "cooling_rate", "sample_date": "timestamp", "sample_alpha95": "dir_alpha95", "er_scientist_mail_names": "scientists", "sample_orientation_flag": "orientation_quality", "sample_int": "int_abs", "sample_n_lines": "dir_n_specimens_lines", "sample_igsn": "igsn", "magic_method_codes": "method_codes", "pmag_criteria_codes": "criteria", "sample_texture": "texture", "sample_n_planes": "dir_n_specimens_planes", "magic_instrument_codes": "instrument_codes", "sample_declination_correction": "azimuth_dec_correction", "sample_inc": "dir_inc", "sample_polarity": "dir_polarity", "er_analyst_mail_names": "analysts", "sample_comp_name": "dir_comp_name", "sample_class": "geologic_classes", "er_sample_alternatives": "sample_alternatives", "magic_experiment_names": "experiments", "er_synthetic_names": "specimens", "external_database_names": "external_database_ids", "er_sample_name": "sample", "sample_r": "dir_r", "sample_magn_volume": "magn_volume", "sample_n": "dir_n_specimens", "sample_comp_n": "dir_n_comps", "sample_magn_mass": "magn_mass", "sample_k": "dir_k", "sample_tilt_correction": "dir_tilt_correction", "er_site_name": "site", "sample_flag": "result_quality", "sample_int_rel_sigma": "int_rel_sigma", "sample_dip": "dip", "sample_lon": "lon", "external_database_ids": "external_database_ids"},
    "criteria": {"pmag_criteria_code": "criterion", "er_citation_names": "citations", "criteria_definition": "description"},
    "images": {"er_citation_names": "citations", "image_type": "type", "image_description": "description", "er_sample_name": "sample", "er_site_name": "site", "er_location_name": "location", "er_image_name": "file", "er_synthetic_name": "specimen", "er_image_alternatives": "description", "image_keywords": "keywords", "er_photographer_mail_names": "photographers", "image_title": "title", "image_date": "timestamp", "image_time_zone": "timestamp", "er_specimen_name": "specimen"},
    "contribution": {},
    "specimens": {"specimen_size": "size", "specimen_shape": "shape", "specimen_dang": "dir_dang", "specimen_alteration": "alteration_grade", "specimen_r_sq": "int_r2_corr", "specimen_igsn": "igsn", "specimen_alteration_type": "alteration_type", "er_scientist_mail_names": "scientists", "specimen_int_sigma_perc": "int_abs_sigma_perc", "specimen_description": "description", "specimen_int_ptrm_tail_n": "int_n_ptrm_tail", "specimen_viscosity_index": "int_viscosity_index", "specimen_maxdev": "int_maxdev", "specimen_flag": "result_quality", "specimen_dtr": "int_dtr", "specimen_lab_field_ac": "susc_lab_field_ac_high", "specimen_int_mad_anc": "int_mad_anc", "specimen_k_sse": "int_k_sse", "specimen_tilt_correction": "dir_tilt_correction", "specimen_int_ptrm_n": "int_n_ptrm", "specimen_delta": "int_delta", "specimen_int_rel_sigma_perc": "int_rel_sigma_perc", "specimen_ac_n": "int_n_ac", "specimen_theta": "int_theta", "er_citation_names": "citations", "specimen_int_dang": "int_dang", "specimen_volume": "volume", "measurement_step_max": "meas_step_max", "specimen_lab_field_dc": "int_treat_dc_field", "specimen_int": "int_abs", "specimen_b_beta": "int_b_beta", "magic_method_codes": "method_codes", "specimen_dac": "int_dac", "specimen_int_n": "int_n_measurements", "specimen_z_md": "int_z_md", "specimen_inc": "dir_inc", "specimen_magn_moment": "magn_moment", "er_specimen_alternatives": "specimen_alternatives", "specimen_int_corr_nlt": "int_corr_nlt", "specimen_dip": "dip", "specimen_class": "geologic_classes", "specimen_int_corr_cooling_rate": "int_corr_cooling_rate", "specimen_fvds": "int_fvds", "specimen_polarity": "dir_polarity", "specimen_drats": "int_drats", "specimen_texture": "texture", "specimen_magn_volume": "magn_volume", "specimen_mad": "dir_mad_free", "specimen_drat": "int_drat", "specimen_alpha_prime": "int_alpha_prime", "specimen_alpha": "dir_alpha", "specimen_mdev": "int_mdev", "specimen_magn_mass": "magn_mass", "measurement_step_unit": "meas_step_unit", "specimen_frac": "int_frac", "specimen_int_rel": "int_rel", "specimen_lithology": "lithologies", "specimen_mdrat": "int_mdrat", "specimen_dck": "int_dck", "specimen_gamma": "int_gamma", "specimen_tail_drat": "int_drat_tail", "er_specimen_name": "specimen", "specimen_gmax": "int_gmax", "specimen_int_corr_anisotropy": "int_corr_anisotropy", "specimen_int_mad": "int_mad_free", "magic_instrument_codes": "instrument_codes", "specimen_b": "int_b", "external_database_ids": "external_database_ids", "specimen_ptrm": "int_ptrm", "specimen_alpha95": "dir_alpha95", "specimen_int_rel_sigma": "int_rel_sigma", "er_analyst_mail_names": "analysts", "specimen_md": "int_md", "specimen_int_alpha": "int_alpha", "specimen_correction": "int_corr", "magic_experiment_names": "experiments", "specimen_rsc": "int_rsc", "external_database_names": "external_database_ids", "specimen_int_sigma": "int_abs_sigma", "specimen_comp_nmb": "dir_comp", "measurement_step_min": "meas_step_min", "specimen_nrm": "dir_nrm_origin", "specimen_scat": "int_scat", "specimen_mad_anc": "dir_mad_anc", "specimen_weight": "weight", "specimen_b_sigma": "int_b_sigma", "magic_software_packages": "software_packages", "specimen_density": "density", "er_sample_name": "sample", "er_synthetic_name": "specimen", "specimen_azimuth": "azimuth", "specimen_cdrat": "int_cdrat", "pmag_criteria_codes": "criteria", "specimen_int_crm": "int_crm", "specimen_dec": "dir_dec", "specimen_type": "geologic_types", "specimen_comp_name": "dir_comp", "specimen_dpal": "int_dpal", "specimen_g": "int_g", "specimen_f": "int_f", "specimen_k": "int_k", "specimen_n": "dir_n_measurements", "specimen_q": "int_q", "specimen_dt": "int_dt", "specimen_comp_n": "dir_n_comps", "specimen_w": "int_w", "specimen_z": "int_z", "specimen_coeff_det_sq": "int_r2_det"}}
